{-# LANGUAGE ImportQualifiedPost #-}
{-# LANGUAGE OverloadedStrings #-}

module Main (main) where

import Data.ByteString.Char8 qualified as B
import Data.Text.IO qualified as T
import Main.LLVMGen
import Main.Parser.Megaparsec
import System.Environment
import System.Process (callCommand)

main :: IO ()
main = do
  fileName <- head <$> getArgs
  contents <- T.readFile fileName
  T.putStrLn "- Generating LLVM to './a.out.ll'..."
  result <- (llvmGen . parse) contents
  B.writeFile "a.out.ll" result
  T.putStrLn "- Compiling to executable './a.out'..."
  callCommand "clang a.out.ll"
  T.putStrLn "- Done."